require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_CHECKSUM_H)) {
    eval 'sub __SPARC_CHECKSUM_H () {1;}' unless defined(&__SPARC_CHECKSUM_H);
    require 'linux/in6.ph';
    require 'asm/uaccess.ph';
    require 'asm/cprefix.ph';
    eval 'sub csum_partial_copy {
        local($src, $dst, $len, $sum) = @_;
	    eval q( &csum_partial_copy_nocheck($src,$dst,$len,$sum));
    }' unless defined(&csum_partial_copy);
    eval 'sub csum_partial_copy_fromuser {
        local($s, $d, $l, $w) = @_;
	    eval q( &csum_partial_copy( ($s), ($d), ($l), ($w)));
    }' unless defined(&csum_partial_copy_fromuser);
    eval 'sub csum_partial_copy_nocheck {
        local($src,$dst,$len,$sum) = @_;
	    eval q({  &register  &unsigned int ret asm(\\"o0\\") = $src;  &register \'char\' * &d  &asm(\\"o1\\") = $dst;  &register \'int\'  &l  &asm(\\"g1\\") = $len;  &__asm__  &__volatile__ ( \\"call \\"  &C_LABEL_STR( &__csum_partial_copy_sparc_generic) \\"\\\\n\\\\t\\" \\" mov %6, %%g7\\\\n\\" : \\"=&r\\" ( &ret), \\"=&r\\" ( &d), \\"=&r\\" ( &l) : \\"0\\" ( &ret), \\"1\\" ( &d), \\"2\\" ( &l), \\"r\\" ($sum) : \\"o2\\", \\"o3\\", \\"o4\\", \\"o5\\", \\"o7\\", \\"g2\\", \\"g3\\", \\"g4\\", \\"g5\\", \\"g7\\", \\"memory\\", \\"cc\\");  &ret; });
    }' unless defined(&csum_partial_copy_nocheck);
    eval 'sub csum_partial_copy_from_user {
        local($src,$dst,$len,$sum,$err) = @_;
	    eval q({  &if (! &access_ok ( &VERIFY_READ, $src, $len)) { *$err = - &EFAULT;  &memset ($dst, 0, $len); $sum; }  &else {  &register  &unsigned int ret asm(\\"o0\\") = $src;  &register \'char\' * &d  &asm(\\"o1\\") = $dst;  &register \'int\'  &l  &asm(\\"g1\\") = $len;  &register  &unsigned int s asm(\\"g7\\") = $sum;  &__asm__  &__volatile__ ( \\".section __ex_table,#alloc\\\\n\\\\t\\" \\".align 4\\\\n\\\\t\\" \\".word 1f,2\\\\n\\\\t\\" \\".previous\\\\n\\" \\"1:\\\\n\\\\t\\" \\"call \\"  &C_LABEL_STR \\"\\\\n\\\\t\\" \\" st %8, [%%sp + 64]\\\\n\\" : \\"=&r\\" , \\"=&r\\" , \\"=&r\\" , \\"=&r\\" : \\"0\\" , \\"1\\" , \\"2\\" , \\"3\\" , \\"r\\" : \\"o2\\", \\"o3\\", \\"o4\\", \\"o5\\", \\"o7\\", \\"g2\\", \\"g3\\", \\"g4\\", \\"g5\\", \\"cc\\", \\"memory\\");  &ret; } }  &unsigned int csum_partial_copy_to_user( &const \'char\' *$src, \'char\' *$dst, \'int\' $len, my $sum, \'int\' *$err) {  &if (! &access_ok ( &VERIFY_WRITE, $dst, $len)) { *$err = - &EFAULT; $sum; }  &else {  &register  &unsigned int ret asm(\\"o0\\") = $src;  &register \'char\' * &d  &asm(\\"o1\\") = $dst;  &register \'int\'  &l  &asm(\\"g1\\") = $len;  &register  &unsigned int s asm(\\"g7\\") = $sum;  &__asm__  &__volatile__ ( \\".section __ex_table,#alloc\\\\n\\\\t\\" \\".align 4\\\\n\\\\t\\" \\".word 1f,1\\\\n\\\\t\\" \\".previous\\\\n\\" \\"1:\\\\n\\\\t\\" \\"call \\"  &C_LABEL_STR( &__csum_partial_copy_sparc_generic) \\"\\\\n\\\\t\\" \\" st %8, [%%sp + 64]\\\\n\\" : \\"=&r\\" ( &ret), \\"=&r\\" ( &d), \\"=&r\\" ( &l), \\"=&r\\" ( &s) : \\"0\\" ( &ret), \\"1\\" ( &d), \\"2\\" ( &l), \\"3\\" ( &s), \\"r\\" ($err) : \\"o2\\", \\"o3\\", \\"o4\\", \\"o5\\", \\"o7\\", \\"g2\\", \\"g3\\", \\"g4\\", \\"g5\\", \\"cc\\", \\"memory\\");  &ret; } });
    }' unless defined(&csum_partial_copy_from_user);
    eval 'sub HAVE_CSUM_COPY_USER () {1;}' unless defined(&HAVE_CSUM_COPY_USER);
    eval 'sub csum_and_copy_to_user () { &csum_partial_copy_to_user;}' unless defined(&csum_and_copy_to_user);
    eval 'sub csum_tcpudp_nofold {
        local($saddr,$daddr,$len,$proto,$sum) = @_;
	    eval q({  &__asm__  &__volatile__(\\"addcc\\\\t%1, %0, %0\\\\n\\\\t\\" \\"addxcc\\\\t%2, %0, %0\\\\n\\\\t\\" \\"addxcc\\\\t%3, %0, %0\\\\n\\\\t\\" \\"addx\\\\t%0, %%g0, %0\\\\n\\\\t\\" : \\"=r\\" ($sum), \\"=r\\" ($saddr) : \\"r\\" ($daddr), \\"r\\" (($proto<<16)+$len), \\"0\\" ($sum), \\"1\\" ($saddr) : \\"cc\\"); $sum; });
    }' unless defined(&csum_tcpudp_nofold);
    eval 'sub _HAVE_ARCH_IPV6_CSUM () {1;}' unless defined(&_HAVE_ARCH_IPV6_CSUM);
    eval 'sub csum_ipv6_magic {
        local($saddr,$daddr,$len,$proto,$sum) = @_;
	    eval q({  &__asm__  &__volatile__ ( \\"addcc	%3, %4, %%g4\\\\n\\\\t\\" \\"addxcc	%5, %%g4, %%g4\\\\n\\\\t\\" \\"ld	[%2 + 0x0c], %%g2\\\\n\\\\t\\" \\"ld	[%2 + 0x08], %%g3\\\\n\\\\t\\" \\"addxcc	%%g2, %%g4, %%g4\\\\n\\\\t\\" \\"ld	[%2 + 0x04], %%g2\\\\n\\\\t\\" \\"addxcc	%%g3, %%g4, %%g4\\\\n\\\\t\\" \\"ld	[%2 + 0x00], %%g3\\\\n\\\\t\\" \\"addxcc	%%g2, %%g4, %%g4\\\\n\\\\t\\" \\"ld	[%1 + 0x0c], %%g2\\\\n\\\\t\\" \\"addxcc	%%g3, %%g4, %%g4\\\\n\\\\t\\" \\"ld	[%1 + 0x08], %%g3\\\\n\\\\t\\" \\"addxcc	%%g2, %%g4, %%g4\\\\n\\\\t\\" \\"ld	[%1 + 0x04], %%g2\\\\n\\\\t\\" \\"addxcc	%%g3, %%g4, %%g4\\\\n\\\\t\\" \\"ld	[%1 + 0x00], %%g3\\\\n\\\\t\\" \\"addxcc	%%g2, %%g4, %%g4\\\\n\\\\t\\" \\"addxcc	%%g3, %%g4, %0\\\\n\\\\t\\" \\"addx	0, %0, %0\\\\n\\" : \\"=&r\\" ($sum) : \\"r\\" ($saddr), \\"r\\" ($daddr), \\"r\\"( &htonl($len)), \\"r\\"( &htonl($proto)), \\"r\\"($sum) : \\"g2\\", \\"g3\\", \\"g4\\", \\"cc\\");  &csum_fold($sum); });
    }' unless defined(&csum_ipv6_magic);
}
1;
