require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_PAGE_H)) {
    eval 'sub _SPARC_PAGE_H () {1;}' unless defined(&_SPARC_PAGE_H);
    require 'linux/config.ph';
    if(defined(&CONFIG_SUN4)) {
	eval 'sub PAGE_SHIFT () {13;}' unless defined(&PAGE_SHIFT);
    } else {
	eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    }
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    } else {
	eval 'sub PAGE_SIZE () {(1<<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    }
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    if(defined(&__KERNEL__)) {
	require 'asm/head.ph';
	require 'asm/btfixup.ph';
	eval 'sub TASK_UNION_SIZE () {8192;}' unless defined(&TASK_UNION_SIZE);
	unless(defined(&__ASSEMBLY__)) {
	    if(0) {
		eval 'sub BUG () {
		    eval q( &do {  &mb();  &__builtin_trap();  &mb(); }  &while(0));
		}' unless defined(&BUG);
	    } else {
		eval 'sub BUG () {
		    eval q( &do {  &printk(\\"kernel BUG at %s:%d!\\\\n\\",  &__FILE__,  &__LINE__); *0=0; }  &while (0));
		}' unless defined(&BUG);
	    }
	    eval 'sub PAGE_BUG {
	        local($page) = @_;
    		eval q( &BUG());
	    }' unless defined(&PAGE_BUG);
	    eval 'sub clear_page {
	        local($page) = @_;
    		eval q( &memset(( &void *)($page), 0,  &PAGE_SIZE));
	    }' unless defined(&clear_page);
	    eval 'sub copy_page {
	        local($to,$from) = @_;
    		eval q( &memcpy(( &void *)($to), ( &void *)($from),  &PAGE_SIZE));
	    }' unless defined(&copy_page);
	    eval 'sub clear_user_page {
	        local($page, $vaddr) = @_;
    		eval q( &clear_page($page));
	    }' unless defined(&clear_user_page);
	    eval 'sub copy_user_page {
	        local($to, $from, $vaddr) = @_;
    		eval q( &copy_page($to, $from));
	    }' unless defined(&copy_user_page);
	    eval 'sub SPARC_PHYS_BANKS () {32;}' unless defined(&SPARC_PHYS_BANKS);
	    if(defined(&STRICT_MM_TYPECHECKS)) {
		eval 'sub pte_val {
		    local($x) = @_;
    		    eval q((($x). &pte));
		}' unless defined(&pte_val);
		eval 'sub iopte_val {
		    local($x) = @_;
    		    eval q((($x). &iopte));
		}' unless defined(&iopte_val);
		eval 'sub pmd_val {
		    local($x) = @_;
    		    eval q((($x). &pmd));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    local($x) = @_;
    		    eval q((($x). &pgd));
		}' unless defined(&pgd_val);
		eval 'sub ctxd_val {
		    local($x) = @_;
    		    eval q((($x). &ctxd));
		}' unless defined(&ctxd_val);
		eval 'sub pgprot_val {
		    local($x) = @_;
    		    eval q((($x). &pgprot));
		}' unless defined(&pgprot_val);
		eval 'sub iopgprot_val {
		    local($x) = @_;
    		    eval q((($x). &iopgprot));
		}' unless defined(&iopgprot_val);
		eval 'sub __pte {
		    local($x) = @_;
    		    eval q((( &pte_t) { ($x) } ));
		}' unless defined(&__pte);
		eval 'sub __iopte {
		    local($x) = @_;
    		    eval q((( &iopte_t) { ($x) } ));
		}' unless defined(&__iopte);
		eval 'sub __pmd {
		    local($x) = @_;
    		    eval q((( &pmd_t) { ($x) } ));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    local($x) = @_;
    		    eval q((( &pgd_t) { ($x) } ));
		}' unless defined(&__pgd);
		eval 'sub __ctxd {
		    local($x) = @_;
    		    eval q((( &ctxd_t) { ($x) } ));
		}' unless defined(&__ctxd);
		eval 'sub __pgprot {
		    local($x) = @_;
    		    eval q((( &pgprot_t) { ($x) } ));
		}' unless defined(&__pgprot);
		eval 'sub __iopgprot {
		    local($x) = @_;
    		    eval q((( &iopgprot_t) { ($x) } ));
		}' unless defined(&__iopgprot);
	    } else {
		eval 'sub pte_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pte_val);
		eval 'sub iopte_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&iopte_val);
		eval 'sub pmd_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgd_val);
		eval 'sub ctxd_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&ctxd_val);
		eval 'sub pgprot_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgprot_val);
		eval 'sub iopgprot_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&iopgprot_val);
		eval 'sub __pte {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pte);
		eval 'sub __iopte {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__iopte);
		eval 'sub __pmd {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgd);
		eval 'sub __ctxd {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__ctxd);
		eval 'sub __pgprot {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgprot);
		eval 'sub __iopgprot {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__iopgprot);
	    }
	    eval 'sub TASK_UNMAPPED_BASE () { &BTFIXUP_SETHI( &sparc_unmapped_base);}' unless defined(&TASK_UNMAPPED_BASE);
	} else {
	    eval 'sub __pgprot {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&__pgprot);
	}
	eval 'sub PAGE_ALIGN {
	    local($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub PAGE_OFFSET () {0xf0000000;}' unless defined(&PAGE_OFFSET);
	eval 'sub __pa {
	    local($x) = @_;
    	    eval q((($x) -  &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    local($x) = @_;
    	    eval q((( &void *)( ($x) +  &PAGE_OFFSET)));
	}' unless defined(&__va);
	eval 'sub virt_to_page {
	    local($kaddr) = @_;
    	    eval q(( &mem_map + ( &__pa($kaddr) >>  &PAGE_SHIFT)));
	}' unless defined(&virt_to_page);
	eval 'sub VALID_PAGE {
	    local($page) = @_;
    	    eval q((($page -  &mem_map) <  &max_mapnr));
	}' unless defined(&VALID_PAGE);
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
    }
}
1;
