require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_PGALLOC_H)) {
    eval 'sub _SPARC_PGALLOC_H () {1;}' unless defined(&_SPARC_PGALLOC_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    require 'linux/sched.ph';
    require 'asm/page.ph';
    require 'asm/btfixup.ph';
    if(defined(&CONFIG_SMP)) {
	eval 'sub local_flush_cache_all () {
	    eval q( &BTFIXUP_CALL( &local_flush_cache_all)());
	}' unless defined(&local_flush_cache_all);
	eval 'sub local_flush_cache_mm {
	    local($mm) = @_;
    	    eval q( &BTFIXUP_CALL( &local_flush_cache_mm)($mm));
	}' unless defined(&local_flush_cache_mm);
	eval 'sub local_flush_cache_range {
	    local($mm,$start,$end) = @_;
    	    eval q( &BTFIXUP_CALL( &local_flush_cache_range)($mm,$start,$end));
	}' unless defined(&local_flush_cache_range);
	eval 'sub local_flush_cache_page {
	    local($vma,$addr) = @_;
    	    eval q( &BTFIXUP_CALL( &local_flush_cache_page)($vma,$addr));
	}' unless defined(&local_flush_cache_page);
	eval 'sub local_flush_tlb_all () {
	    eval q( &BTFIXUP_CALL( &local_flush_tlb_all)());
	}' unless defined(&local_flush_tlb_all);
	eval 'sub local_flush_tlb_mm {
	    local($mm) = @_;
    	    eval q( &BTFIXUP_CALL( &local_flush_tlb_mm)($mm));
	}' unless defined(&local_flush_tlb_mm);
	eval 'sub local_flush_tlb_range {
	    local($mm,$start,$end) = @_;
    	    eval q( &BTFIXUP_CALL( &local_flush_tlb_range)($mm,$start,$end));
	}' unless defined(&local_flush_tlb_range);
	eval 'sub local_flush_tlb_page {
	    local($vma,$addr) = @_;
    	    eval q( &BTFIXUP_CALL( &local_flush_tlb_page)($vma,$addr));
	}' unless defined(&local_flush_tlb_page);
	eval 'sub local_flush_page_to_ram {
	    local($addr) = @_;
    	    eval q( &BTFIXUP_CALL( &local_flush_page_to_ram)($addr));
	}' unless defined(&local_flush_page_to_ram);
	eval 'sub local_flush_sig_insns {
	    local($mm,$insn_addr) = @_;
    	    eval q( &BTFIXUP_CALL( &local_flush_sig_insns)($mm,$insn_addr));
	}' unless defined(&local_flush_sig_insns);
    }
    eval 'sub flush_cache_all () {
        eval q( &BTFIXUP_CALL( &flush_cache_all)());
    }' unless defined(&flush_cache_all);
    eval 'sub flush_cache_mm {
        local($mm) = @_;
	    eval q( &BTFIXUP_CALL( &flush_cache_mm)($mm));
    }' unless defined(&flush_cache_mm);
    eval 'sub flush_cache_range {
        local($mm,$start,$end) = @_;
	    eval q( &BTFIXUP_CALL( &flush_cache_range)($mm,$start,$end));
    }' unless defined(&flush_cache_range);
    eval 'sub flush_cache_page {
        local($vma,$addr) = @_;
	    eval q( &BTFIXUP_CALL( &flush_cache_page)($vma,$addr));
    }' unless defined(&flush_cache_page);
    eval 'sub flush_icache_range {
        local($start, $end) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_icache_range);
    eval 'sub flush_tlb_pgtables {
        local($mm,$start,$end) = @_;
	    eval q({ });
    }' unless defined(&flush_tlb_pgtables);
    eval 'sub flush_tlb_all () {
        eval q( &BTFIXUP_CALL( &flush_tlb_all)());
    }' unless defined(&flush_tlb_all);
    eval 'sub flush_tlb_mm {
        local($mm) = @_;
	    eval q( &BTFIXUP_CALL( &flush_tlb_mm)($mm));
    }' unless defined(&flush_tlb_mm);
    eval 'sub flush_tlb_range {
        local($mm,$start,$end) = @_;
	    eval q( &BTFIXUP_CALL( &flush_tlb_range)($mm,$start,$end));
    }' unless defined(&flush_tlb_range);
    eval 'sub flush_tlb_page {
        local($vma,$addr) = @_;
	    eval q( &BTFIXUP_CALL( &flush_tlb_page)($vma,$addr));
    }' unless defined(&flush_tlb_page);
    eval 'sub __flush_page_to_ram {
        local($addr) = @_;
	    eval q( &BTFIXUP_CALL( &__flush_page_to_ram)($addr));
    }' unless defined(&__flush_page_to_ram);
    eval 'sub flush_sig_insns {
        local($mm,$insn_addr) = @_;
	    eval q( &BTFIXUP_CALL( &flush_sig_insns)($mm,$insn_addr));
    }' unless defined(&flush_sig_insns);
    eval 'sub flush_dcache_page {
        local($page) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_dcache_page);
    eval 'sub pgd_quicklist () {( ($pgt_quicklists->{pgd_cache}));}' unless defined(&pgd_quicklist);
    eval 'sub pmd_quicklist () {(0);}' unless defined(&pmd_quicklist);
    eval 'sub pte_quicklist () {( ($pgt_quicklists->{pte_cache}));}' unless defined(&pte_quicklist);
    eval 'sub pgtable_cache_size () {( ($pgt_quicklists->{pgtable_cache_sz}));}' unless defined(&pgtable_cache_size);
    eval 'sub pgd_cache_size () {( ($pgt_quicklists->{pgd_cache_sz}));}' unless defined(&pgd_cache_size);
    eval 'sub do_check_pgt_cache {
        local($low,$high) = @_;
	    eval q( &BTFIXUP_CALL( &do_check_pgt_cache)($low,$high));
    }' unless defined(&do_check_pgt_cache);
    eval 'sub get_pgd_fast () {
        eval q( &BTFIXUP_CALL( &get_pgd_fast)());
    }' unless defined(&get_pgd_fast);
    eval 'sub free_pgd_fast {
        local($pgd) = @_;
	    eval q( &BTFIXUP_CALL( &free_pgd_fast)($pgd));
    }' unless defined(&free_pgd_fast);
    eval 'sub pgd_free {
        local($pgd) = @_;
	    eval q( &free_pgd_fast($pgd));
    }' unless defined(&pgd_free);
    eval 'sub pgd_alloc {
        local($mm) = @_;
	    eval q( &get_pgd_fast());
    }' unless defined(&pgd_alloc);
    eval 'sub pgd_populate {
        local($MM, $PGD, $PMD) = @_;
	    eval q( &pgd_set($PGD, $PMD));
    }' unless defined(&pgd_populate);
    eval 'sub pmd_t {
        eval q(* &pmd_alloc_one(\'struct mm_struct\' * &mm, my $address) { 0; });
    }' unless defined(&pmd_t);
    eval 'sub pmd_alloc_one_fast {
        local($mm, $address) = @_;
	    eval q( &BTFIXUP_CALL( &pmd_alloc_one_fast)($mm, $address));
    }' unless defined(&pmd_alloc_one_fast);
    eval 'sub free_pmd_fast {
        local($pmd) = @_;
	    eval q( &BTFIXUP_CALL( &free_pmd_fast)($pmd));
    }' unless defined(&free_pmd_fast);
    eval 'sub pmd_free {
        local($pmd) = @_;
	    eval q( &free_pmd_fast($pmd));
    }' unless defined(&pmd_free);
    eval 'sub pmd_populate {
        local($MM, $PMD, $PTE) = @_;
	    eval q( &pmd_set($PMD, $PTE));
    }' unless defined(&pmd_populate);
    eval 'sub pte_alloc_one {
        local($mm, $address) = @_;
	    eval q( &BTFIXUP_CALL( &pte_alloc_one)($mm, $address));
    }' unless defined(&pte_alloc_one);
    eval 'sub pte_alloc_one_fast {
        local($mm, $address) = @_;
	    eval q( &BTFIXUP_CALL( &pte_alloc_one_fast)($mm, $address));
    }' unless defined(&pte_alloc_one_fast);
    eval 'sub free_pte_fast {
        local($pte) = @_;
	    eval q( &BTFIXUP_CALL( &free_pte_fast)($pte));
    }' unless defined(&free_pte_fast);
    eval 'sub pte_free {
        local($pte) = @_;
	    eval q( &free_pte_fast($pte));
    }' unless defined(&pte_free);
}
1;
